#include "udprxasync.h"
#include "ui_udprxasync.h"
#include <QTimer>

UdpRxAsync::UdpRxAsync(QWidget *parent)
    : QWidget(parent)
    , ui(new Ui::UdpRxAsync)
{
    ui->setupUi(this);
    nPort = PORT_BY_DEFAULT;
    udpSocketEscoltador = NULL;
    vCanviaPort(QString::number(nPort));
    connect(ui->lineEdit,SIGNAL(textChanged(QString)),
            this,SLOT(vCanviaPort(QString)));
}

UdpRxAsync::~UdpRxAsync()
{
    delete ui;
}

bool UdpRxAsync::bInitSocket(quint16 nP){
    bool bRunning;

    if(udpSocketEscoltador){
        udpSocketEscoltador->deleteLater();
        disconnect(udpSocketEscoltador);
        delete udpSocketEscoltador;
        udpSocketEscoltador = NULL;
    }
    udpSocketEscoltador = new QUdpSocket(this);
    //udpSocketEscoltador->bind(QHostAddress::LocalHost, nPort);
    bRunning = udpSocketEscoltador->bind(QHostAddress::AnyIPv4, nP);


    connect(udpSocketEscoltador, SIGNAL(readyRead()),
            this, SLOT(vlecturaDatagramesPendents()));

    return bRunning;
}

void UdpRxAsync::vCanviaPort(QString szP){
    quint16 nP = szP.toInt();
    nPort = (quint16)nP;

    QString qsz;
    if(bInitSocket(nPort)){
        qsz = "Rx Port: " + QString::number(nPort);
        ui->et0->setStyleSheet("QLabel { color : green; }");
    }else{
        qsz = "Rx Port " + QString::number(nPort) +" ocupat";
        ui->et0->setStyleSheet("QLabel { color : red; }");
    }
    ui->et0->setText(qsz);
}

void UdpRxAsync::vRemoveInfo(){
    ui->etMissatge->setText("MISSATGE");
}

void UdpRxAsync::vlecturaDatagramesPendents(){
    qDebug() << "Un datagrama";
    while (udpSocketEscoltador->hasPendingDatagrams()) {
        QNetworkDatagram datagram = udpSocketEscoltador->receiveDatagram();
        vProcessaDatagrama(datagram);
    }
}

void UdpRxAsync::vProcessaDatagrama(QNetworkDatagram datagram){
    QByteArray qbaDatagrama = datagram.data();

    QString qsz = "Des de " + datagram.senderAddress().toString() + ": ";
    qsz += qbaDatagrama;

    qDebug() << qsz;

    ui->etMissatge->setText(qsz);

    QTimer::singleShot(1000, this, SLOT(vRemoveInfo()));

    if(qsz.right(2) == "4L") ui->etBoto4->setText("Botó 4 premut");
    if(qsz.right(2) == "4H") ui->etBoto4->setText("Botó 4 NO premut");
    if(qsz.right(2) == "0L") ui->etBoto0->setText("Botó 0 premut");
    if(qsz.right(2) == "0H") ui->etBoto0->setText("Botó 0 NO premut");


//    qsz = "Des de <font color=\"red\">" + datagram.senderAddress().toString() + "</font>: ";
//    qsz += "<font color=\"blue\">" + qbaDatagrama + "</font>";
//    ui->plainTextEdit->appendHtml(qsz);
}
